library ieee;
use ieee.std_logic_1164.all;
use work.const.all;



entity if_latch is
port (
	clk: in std_logic;
	reset: in std_logic;
	stall: in std_logic;
	nop: in std_logic;
	
	ir_in : in dat_type;
	exc_vector_in : in exc_vector_type;
	i_isValid: in std_logic;

	ir_out : out dat_type;
	exc_vector_out : out exc_vector_type;
	o_isValid: out std_logic

);
end entity if_latch;

architecture behav of if_latch is
begin

	latch: process(clk, reset, nop, stall) is
	begin
		if (reset = '1') then
			--pc_out <= (others => '0');
			ir_out <= (others => '0');
			exc_vector_out <= (others => '0');
			o_isValid <= '0';
		elsif clk = '1' and clk'event and stall = '0' then
			if nop = '1' then
				ir_out <= (others => '0');
				exc_vector_out <= (others => '0'); --if we nop instruction for other reason, we don't care about exceptions it made
				o_isValid <= '0';
			else
				ir_out <= ir_in;
				exc_vector_out <= exc_vector_in;
				o_isValid <= '1';
			end if;
		end if;
	end process latch;
end architecture behav;
